// Achtung ! Nutzung des gp (GlobalPointer) in Makefile mit -G0 ausschalten !!
// coderight by bITmASTER, eMail: bITmASTER@bigfoot.com

#include "libpsx.h"
#include "waveout.h"

void vbl_int( void );

short *sound = (short *) 0x80080000;
short *sound_end = (short *) ( 0x80080000 + 1478656 );

volatile short *int_mask = (short *) 0x1f801074;

volatile int vbl_count = 0x80080000;


int main( void )
{	
    int i;
	short *left, *right;
	int vbl_event, dma_event;
	PLAY_BUF *play_buf;
		
	exit_critic();
	int_off( 0xffff );

	xprintf( "16 Bit Stereo 22050 Hz Player, coded by bITmASTER\n" );
	
	xprintf( "playing...\n" );

	play_buf = WaveOutInit( &dma_event );
	vbl_event = OpenEvent( 0xf2000003, 0x2, 0x1000, vbl_int );

	EnableEvent( vbl_event );
	EnableEvent( dma_event );
	
	int_on( 0x09 );	// DMA + VBL
	xprintf( "Int-enable: %04.4x\n", *int_mask & 0xffff );
	
	while( 1 ) {
		i = vbl_count;
		while( i == vbl_count );					// wait for vbl
		WaveOutFillSpu();
		
		if ( play_stock <= ( PLAY_BUF_SIZE - 512 ) ) {
			left = &play_buf->l[play_pos_in];
			right = &play_buf->r[play_pos_in];
			
			for ( i = 0; i < 512; i++ ) {
				*left++ = *sound++;
				*right++ = *sound++;
			}
			
			if ( sound >= sound_end )
				sound = (short *) 0x80080000;
			play_pos_in = ( play_pos_in + 512 ) & ( PLAY_BUF_SIZE - 1 ); 
			play_stock += 512;
		}			
	}
	
	int_off( 0xffff );
	xprintf( "the end\n" );
	return( 1 );
}

void vbl_int( void )
{
	vbl_count++;
}